/*
** authored by rue
*/

var AjaxIntercept = {
    
	ProtocolName: "Adblock Ajax Intercept",
	ContractID: "@adblock.mozdev.org/ajax_intercept;3", // XXX Note the number -- we're at ";3"
	cid: Components.ID("{669409b9-2e3b-4682-a5d1-71ca80a76456}"),
 
	load: function() {
		this.olderBrowser           = (typeof(Components.classes["@mozilla.org/network/net-extern-mod;1"]) != 'undefined'); // older browsers had this service, and not the newer observer-notifications
		this.nativeWrappingProvided = (typeof(XPCNativeWrapper) == 'function');
		this.console     = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
        this.prefService = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
		this.prefBranch        = "adblock.";
		this.prefBranchStartup = "ajaxintercept";
		this.rootBranch = this.prefService.getBranch(null);
		this.Branch     = this.prefService.getBranch(this.prefBranch);
		this.active     = false;
		// leeched: from Adblock's component.js, proper
		this.whiteKey         = whiteKey;
		this.AdblockEnabled   = isEnabled;
		this.XMLHTTPREQUEST   = apiConstants.XMLHTTPREQUEST;
		this.isWhite          = isWhite;
		this.isBlocked        = isBlocked;
		this.storeAdblockData = storeAdblockData;
		
		// Component registration
		var compMgr = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactory(this.cid, this.ProtocolName, this.ContractID, this.Factory);

		// Load prefs + filters + Enable
		if (this.Branch.prefHasUserValue(this.prefBranchStartup) && this.Branch.getPrefType(this.prefBranchStartup) != Components.interfaces.nsIPrefBranch.PREF_BOOL)
			this.Branch.deleteBranch(this.prefBranchStartup); // ditch wrong-type pref
		this.startIfEnabled();
	},
	
	log: function(msg) { try{this.console.logStringMessage(msg);} catch(e){;} },
	logfile: function(logString) {	
		var streamOut = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
		var logFile = dirService.get("UChrm", Components.interfaces.nsIFile);// lxr.mozilla.org/seamonkey/source/xpcom/io/nsAppDirectoryServiceDefs.h
		logFile.append("logfile.txt");
		logFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666); // uniquely name file
		if (logFile.isWritable()) {
			streamOut.init(logFile, 0x02, 0x200, null);
			streamOut.write(logString, logString.length);
			streamOut.close(); }
	 },
	
    startIfEnabled: function() {
		var type="getPrefType", boolType = Components.interfaces.nsIPrefBranch.PREF_BOOL;
		if (!(this.Branch[type](this.prefBranchStartup)==boolType) || this.Branch.getBoolPref(this.prefBranchStartup)) // default:true
			this.start(); // we're good
    },
    start: function() {
        if (this.active) return;
		if (this.olderBrowser) { // see:  mozilla/netwerk/base/public/nsINetModuleMgr.idl  ->  http://bonsai.mozilla.org/cvsblame.cgi?file=mozilla/netwerk/base/public/Attic/nsINetModuleMgr.idl&rev=1.12&root=/cvsroot
			var netModuleMgr = Components.classes["@mozilla.org/network/net-extern-mod;1"].getService(Components.interfaces.nsINetModuleMgr);
			netModuleMgr.registerModule("@mozilla.org/network/moduleMgr/http/request;1", this); }
		else { 
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			observerService.addObserver(this, "http-on-modify-request", true); }// bool: ownsWeak
		this.active = true;
    },
    stop: function() {
        if (this.active == false) return;
		if (this.olderBrowser) { 
			var netModuleMgr = Components.classes["@mozilla.org/network/net-extern-mod;1"].getService(Components.interfaces.nsINetModuleMgr);
			netModuleMgr.unregisterModule("@mozilla.org/network/moduleMgr/http/request;1", this); }
		else { 
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			observerService.removeObserver(this, "http-on-modify-request"); }
		this.active = false;
    },
	
	cssExtRe: /\.css$/i,
	cssRe: /\/css$/i,
	ajaxCheck: #1=function(request) {
		request.QueryInterface(Components.interfaces.nsIRequest);
		if (request.loadFlags & Components.interfaces.nsIChannel.LOAD_DOCUMENT_URI) return;
		
		var url = request.URI.spec;
		try{ var ct = request.contentType; }catch(e){}
		if ((ct && this.cssRe.test(ct)) || this.cssExtRe.test(url)) return; // ignore css-files
		
		if (request.loadGroup) {
			var go = request.loadGroup.groupObserver;
			if (go) var wnd = go.QueryInterface(Components.interfaces.nsIWebProgress).DOMWindow; }
        if (!wnd) return;
		var doc = wnd.top.document;
		
	 	if (typeof(doc[this.whiteKey])=='undefined') var white = doc[this.whiteKey] = (this.isWhite(wnd.location+"")!=null ? true:false);
		else white = doc[this.whiteKey];
		
		if (!white) {
			var filterMatch = null;
			var Adblock = doc._Adblock;
			if (Adblock && Adblock[url]) filterMatch = Adblock[url].filterMatch;
			if (filterMatch == null) filterMatch = this.isBlocked(request.URI);  }
		
		if (filterMatch == null) {   //!= false) {   // 'false' means a prior-approved url -- to keep script-urls from showing double, we'll ignore those.
			var hollowNode = {tagName:"XMLHttpRequest"}; //,nodeName:"XMLHttpRequest"}; // XXX we need the nodeName, for the pageblock-check in shouldLoad.  //,defaultView:doc.defaultView};
			this.storeAdblockData(hollowNode, request.URI, this.XMLHTTPREQUEST, filterMatch, null,doc); }
		if (filterMatch) request.cancel(Components.results.NS_ERROR_ABORT);
	},
	
    onModifyRequest : #1#,   // yum, sharp-variables
    observe: function(aSubject, aTopic, aData) {
		if (aTopic == 'http-on-modify-request')
			this.ajaxCheck(aSubject.QueryInterface(Components.interfaces.nsIHttpChannel));
    },

    // nsISupports implementation
    QueryInterface: function(iid) {
        if (!iid.equals(Components.interfaces.nsISupports) &&
			!iid.equals(Components.interfaces.nsISupportsWeakReference) &&
            !iid.equals(Components.interfaces.nsIHttpNotify) &&
            !iid.equals(Components.interfaces.nsIObserver)) {
                this.log("AjaxIntercept: QI unknown interface: " + iid);
                throw Components.results.NS_ERROR_NO_INTERFACE;
            }
        return this;
    },

	Factory: {
		// nsIFactory interface implementation
		createInstance: function(outer, iid) {
			if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
			return AjaxIntercept;
		},
	
		// nsISupports interface implementation
		QueryInterface: function(iid) {
			if (!iid.equals(Components.interfaces.nsISupports) &&
				!iid.equals(Components.interfaces.nsISupportsWeakReference) &&
				!iid.equals(Components.interfaces.nsIFactory))
				throw Components.results.NS_ERROR_NO_INTERFACE;
			return this;
		}
	}
	
};


/*
** fire -!
*/

AjaxIntercept.load();